﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.ComponentModel;
using Infragistics.Windows.DataPresenter;

namespace XamDataGridActiveItem
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
         List<int> selectedRecordsIndexes;
       

        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();
            selectedRecordsIndexes = new List<int>();
           
        }

       

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            xamDataGrid1.DataSource = ((ViewModel)this.DataContext).Data;
        }
               
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            selectedRecordsIndexes.Clear();

            if (xamDataGrid1.SelectedItems.Records != null)
            {
                foreach (var record in xamDataGrid1.SelectedItems.Records)
                {
                    selectedRecordsIndexes.Add(record.Index);
                }
            }

            xamDataGrid1.DataSource = null;
            ((ViewModel)this.DataContext).GetAdditionData();
            xamDataGrid1.DataSource = ((ViewModel)this.DataContext).Data;


            foreach (var index in selectedRecordsIndexes)
                {
                    this.xamDataGrid1.Records[index].IsSelected = true;
                }
             
            
        }

        private void xamDataGrid1_Loaded(object sender, RoutedEventArgs e)
        {
            foreach (var record in this.xamDataGrid1.Records)
            {
                if((bool)(record as DataRecord).Cells["AlreadyChecked"].Value == true)
                {
                    (record as DataRecord).IsSelected = true;
                }
            }

        }
 

        
    }

   
    public class ViewModel : INotifyPropertyChanged
    {
        private List<Person> data;
        public List<Person> Data 
        { 
            get { return data; } 
            set { data = value; NotifyPropertyChanged("Data"); } 
        }
                                
        public ViewModel()
        {
            GetData();
        }
        
        private void GetData()
        {
            Data = new List<Person>();
            Data.Add(new Person() { Id = 0, Age = 10, LastName = "name1", Sex = 'M', AlreadyChecked = true });
            Data.Add(new Person() { Id = 1, Age = 20, LastName = "name2", Sex = 'M', AlreadyChecked = true });
            Data.Add(new Person() { Id = 2, Age = 30, LastName = "name3", Sex = 'M', AlreadyChecked = true });
            Data.Add(new Person() { Id = 3, Age = 50, LastName = "name4", Sex = 'F', AlreadyChecked = true });
            Data.Add(new Person() { Id = 4, Age = 35, LastName = "name5", Sex = 'M', AlreadyChecked = true });
            Data.Add(new Person() { Id = 5, Age = 37, LastName = "name6", Sex = 'F', AlreadyChecked = true });
            Data.Add(new Person() { Id = 6, Age = 14, LastName = "name7", Sex = 'M', AlreadyChecked = true });
            Data.Add(new Person() { Id = 7, Age = 26, LastName = "name8", Sex = 'F', AlreadyChecked = true });
            Data.Add(new Person() { Id = 8, Age = 32, LastName = "name9", Sex = 'F', AlreadyChecked = true });
            Data.Add(new Person() { Id = 9, Age = 27, LastName = "name10", Sex = 'M', AlreadyChecked = false });
            Data.Add(new Person() { Id = 10, Age = 52, LastName = "name11", Sex = 'M', AlreadyChecked = false });
        }

        public void GetAdditionData()
        {
            List<Person> addextra = Data;

            addextra.Add(new Person() { Id = 11, Age = 20, LastName = "name13", Sex = 'M', AlreadyChecked = false });
            addextra.Add(new Person() { Id = 13, Age = 50, LastName = "name14", Sex = 'F', AlreadyChecked = false });
            addextra.Add(new Person() { Id = 14, Age = 35, LastName = "name15", Sex = 'M', AlreadyChecked = false });
            addextra.Add(new Person() { Id = 15, Age = 37, LastName = "name16", Sex = 'F', AlreadyChecked = false });
            addextra.Add(new Person() { Id = 16, Age = 14, LastName = "name17", Sex = 'M', AlreadyChecked = false });
            addextra.Add(new Person() { Id = 17, Age = 26, LastName = "name18", Sex = 'F', AlreadyChecked = false });
            addextra.Add(new Person() { Id = 18, Age = 32, LastName = "name19", Sex = 'F', AlreadyChecked = false });
            addextra.Add(new Person() { Id = 19, Age = 27, LastName = "name20", Sex = 'M', AlreadyChecked = false });

            Data = addextra;       
        }
 
        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }

        }
    }
}
